//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#include <math.h>

#pragma hdrstop

#include "ColumnShow0.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------

bool autoRun = true;

__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    Application->OnIdle = IdleLoop;
    size = 50.0f;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::IdleLoop(TObject*, bool& done)
{
    done = false;
    //RenderGLScene();
    //SwapBuffers(hdc);
    if ( autoRun ) columnShow();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    hdc = GetDC(Handle);
    SetPixelFormatDescriptor();
    hrc = wglCreateContext(hdc);
    if(hrc == NULL)
    	ShowMessage(":-)~ hrc == NULL");
    if(wglMakeCurrent(hdc, hrc) == false)
    	ShowMessage("Could not MakeCurrent");
    w = ClientWidth;
    h = ClientHeight;

    glEnable(GL_DEPTH_TEST);
    //glEnable(GL_CULL_FACE);

    glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
    SetupLighting();
    SetupTextures();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetPixelFormatDescriptor()
{
    PIXELFORMATDESCRIPTOR pfd = {
    	sizeof(PIXELFORMATDESCRIPTOR),
        1,
        PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
        PFD_TYPE_RGBA,
        24,
        0,0,0,0,0,0,
        0,0,
        0,0,0,0,0,
        32,
        0,
        0,
        PFD_MAIN_PLANE,
        0,
        0,0,
    };
    PixelFormat = ChoosePixelFormat(hdc, &pfd);
    SetPixelFormat(hdc, PixelFormat, &pfd);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
    GLfloat nRange = 70.0;

    w = ClientWidth;
    h = ClientHeight;

    if (h == 0)
      h = 1;

    glViewport(0, 0, w, h);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    ///*
    if (w <= h)
        glOrtho (-nRange, nRange, -nRange*h/w, nRange*h/w, -nRange, nRange);
    else
	glOrtho (-nRange*w/h, nRange*w/h, -nRange, nRange, -nRange, nRange);
    //*/
    //For perspective correction
    //GLfloat aspect = (GLfloat)w/(GLfloat)h;
    //gluPerspective(30.0f, aspect, 1.0, 50.0);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    Panel1->Left = Form1->ClientWidth - Panel1->Width - 2;
    Panel1->Top  = Form1->ClientHeight- Panel1->Height- 2;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RenderGLScene()
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    DrawObjects();
    glFlush();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DrawObjects()
{

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    columnShow();
    glFlush();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    wglMakeCurrent(NULL, NULL);
    wglDeleteContext(hrc);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetupLighting()
{
    GLfloat MaterialAmbient[] = {0.5, 0.5, 0.5, 1.0};
    GLfloat MaterialDiffuse[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat MaterialSpecular[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat MaterialShininess[] = {50.0};
    GLfloat AmbientLightPosition[] = {0.5, 1.0, 1.0, 0.0};
    GLfloat LightAmbient[] = {0.5, 0.5, 0.5, 1.0};

    glMaterialfv(GL_FRONT, GL_AMBIENT, MaterialAmbient);
    glMaterialfv(GL_FRONT, GL_DIFFUSE, MaterialDiffuse);
    glMaterialfv(GL_FRONT, GL_SPECULAR, MaterialSpecular);
    glMaterialfv(GL_FRONT, GL_SHININESS, MaterialShininess);
    glLightfv(GL_LIGHT0, GL_POSITION, AmbientLightPosition);
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, LightAmbient);

    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_COLOR_MATERIAL);
    glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
    glShadeModel(GL_SMOOTH);
}
//---------------------------------------------------------------------------

#define SIDE    128
#define Deg2Rad 3.141592653/180.
#define PI      3.141592653

AnsiString filenames[] = {"HappyNewYear.bmp", "ktoplogo.bmp", "Athena1.bmp"};
int latitude=25, longitude=0, incDeg = 2;


void __fastcall TForm1::SetupTextures()
{
    Graphics::TBitmap *bitmap = (Graphics::TBitmap *) new Graphics::TBitmap;
    GLubyte bits[SIDE][SIDE][4];
    int len=SIDE;

    bitmap->LoadFromFile(filenames[0]);
    for(int i = 0; i < len; i++)
    {
    	for(int j = 0; j < len; j++)
        {
            bits[i][j][0]= (GLbyte)GetRValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][1]= (GLbyte)GetGValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][2]= (GLbyte)GetBValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][3]= (GLbyte)255;
        }
    }
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glGenTextures(1, &texture1);
    glBindTexture(GL_TEXTURE_2D, texture1);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, len, len, 0, GL_RGBA, GL_UNSIGNED_BYTE, bits);

    bitmap->LoadFromFile(filenames[1]);
    for(int i = 0; i < len; i++)
    {
    	for(int j = 0; j < len; j++)
        {
            bits[i][j][0]= (GLbyte)GetRValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][1]= (GLbyte)GetGValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][2]= (GLbyte)GetBValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][3]= (GLbyte)255;
        }
    }
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glGenTextures(1, &texture2);
    glBindTexture(GL_TEXTURE_2D, texture2);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, len, len, 0, GL_RGBA, GL_UNSIGNED_BYTE, bits);

    bitmap->LoadFromFile(filenames[2]);
    for(int i = 0; i < len; i++)
    {
    	for(int j = 0; j < len; j++)
        {
            bits[i][j][0]= (GLbyte)GetRValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][1]= (GLbyte)GetGValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][2]= (GLbyte)GetBValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][3]= (GLbyte)255;
        }
    }
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glGenTextures(1, &texture3);
    glBindTexture(GL_TEXTURE_2D, texture3);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, len, len, 0, GL_RGBA, GL_UNSIGNED_BYTE, bits);

    glEnable(GL_TEXTURE_2D);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);

    delete bitmap;
}
//-------------------------------------------------------------------------
struct TimeSetting
{
  int interval, from, to, now;
  bool timing;
  void setTime(int ival, int f, int t, int n=0)
  { interval = ival;  from = f;  to = t;  now = n;
  }
  void trigger()
  { if ( now<to )
      now += interval;
  }
  bool running()
  { if ( now<from || to<=now ) return (false);
    else return (true);
  }
};
#define  TimerNum  8
TimeSetting timeSet[TimerNum];

void setupTimeSet()
{ for (int k=0; k<TimerNum; k++)
     { timeSet[k].interval =    10;
       timeSet[k].from     =     0;
       timeSet[k].to       =  1200;
       timeSet[k].now      =  timeSet[k].from;
     }
}

struct Column
{ float x[3], y[3], height;
  float angle;
};

Column column;

void setupColumn(float r, float h)
{ float x, y, angle;

  angle = PI/2.;
  for (int c=0; c<3; c++)
     { x = r*cos(angle);  y = r*sin(angle);
       column.x[c] = x;
       column.y[c] = y;
       angle += 2.*PI/3;
     }
  column.height = h;
  column.angle  = 0;
}

void __fastcall TForm1::columnShow(bool changeAngle)
{
  float rep=1, drep;
  float angle, dt=36.0, r=8, x, y;
  static degree=0;

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  drep=rep/dt;
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
    glRotated(-latitude, 1.0, 0.0, 0.0);
    glRotated(longitude, 0.0, 0.0, 1.0);

  rep=2; // the number to show the image repeatly.

  ///* triangle column
  setupColumn(r, 100);
  dt = 3;
  static float rot=0.0;
  if ( changeAngle ) rot += incDeg;

  drep = rep/8;
  for (int col=0; col<8; col++)
     { glPushMatrix();
       glTranslatef((col-4)*2*r*0.9, -column.height/2, 0.0);
       glRotated(rot, 0.0, 1.0, 0.0);
       glRotated(-90, 1.0, 0.0, 0.0);

       for (int face=0; face<3; face++)
          { int p=face, next = (p+1)%3;
            rep  = col * drep;
            switch( face )
              { case 0 : glBindTexture(GL_TEXTURE_2D, texture1); break;
                case 1 : glBindTexture(GL_TEXTURE_2D, texture2); break;
                case 2 : glBindTexture(GL_TEXTURE_2D, texture3); break;
              }
            glBegin(GL_QUAD_STRIP);
            glTexCoord2f(1.0, rep);
            glVertex3f(column.x[p], column.y[p], 0);
            glTexCoord2f(0.0, rep);
            glVertex3f(column.x[p], column.y[p], column.height);

            rep += drep;
            glTexCoord2f(1.0, rep);
            glVertex3f(column.x[next], column.y[next], 0);
            glTexCoord2f(0.0, rep);
            glVertex3f(column.x[next], column.y[next], column.height);
            glEnd();
          }
       glBindTexture(GL_TEXTURE_2D, 0);
       glBegin(GL_TRIANGLES); // Top and bottom of the column.
         glColor3f(1.0, 0.0, 0.0);
         glVertex3f(column.x[0], column.y[0], 0);
         glColor3f(0.0, 1.0, 0.0);
         glVertex3f(column.x[2], column.y[2], 0);
         glColor3f(0.0, 0.0, 1.0);
         glVertex3f(column.x[1], column.y[1], 0);
         glColor3f(1.0, 0.0, 0.0);
         glVertex3f(column.x[0], column.y[0], column.height);
         glColor3f(0.0, 1.0, 0.0);
         glVertex3f(column.x[1], column.y[1], column.height);
         glColor3f(0.0, 0.0, 1.0);
         glVertex3f(column.x[2], column.y[2], column.height);
       glEnd();
       glPopMatrix();
     }
  //end of triangle column*/

  glFlush();
  SwapBuffers(hdc);
}

void __fastcall TForm1::bitnLeftClick(TObject *Sender)
{
  incDeg = - abs(incDeg);
  if ( !autoRun ) columnShow();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::bitnRightClick(TObject *Sender)
{
  incDeg = abs(incDeg);
  if ( !autoRun ) columnShow();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UpDown1Click(TObject *Sender, TUDBtnType Button)
{
  incDeg = UpDown1->Position;
}
//---------------------------------------------------------------------------

bool rotating = false;
int prevX, prevY;

void __fastcall TForm1::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  rotating = true;
  prevX = X;
  prevY = Y;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  rotating = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  if ( rotating )
    { int dx = X - prevX;
      int dy = Y - prevY;
      prevX = X;
      prevY = Y;
      latitude  -= dy;
      longitude += dx;
      columnShow(false);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnTextureClick(TObject *Sender)
{
  latitude  = 25;
  longitude =  0;
  columnShow();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::bitnAutoManualClick(TObject *Sender)
{
  autoRun = ! autoRun;
  if ( autoRun )
    { bitnAutoManual->Caption = "Manual Operation";
    }
  else
    { bitnAutoManual->Caption = "Auto Run";
    }
}
//---------------------------------------------------------------------------

